var xhttp =
{
    //xmlhttp : null,
    handler : null,
    uri     : null,
    auxObj  : null,
    init    : function ()
    {
        var xmlhttp;
        if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
	                try {
	                    xmlhttp = new XMLHttpRequest();
	                }   catch (e) {
	                            xmlhttp = false
	                    }
	    }
	    return xmlhttp;
    },
    
    doAsyncPost  : function (postData, getData, handler, uri, contentType)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aHandler = handler, aUri = uri;
			var xmlhttp = this.init();
			if (handler == null)
				aHandler = this.handler;
			if (uri == null)
				aUri = this.uri;

			
			if (xmlhttp == false)
				throw "Error initializing the object";	 
				  	
			xmlhttp.open("POST", aUri + "?" + getData, true); 
			if (contentType == null)
			    contentType = 'application/x-www-form-urlencoded';
			
			var httpHandler = Components.classes["@mozilla.org/network/protocol;1?name=http"].getService(Components.interfaces.nsIHttpProtocolHandler)
			
			xmlhttp.setRequestHeader('User-Agent', httpHandler.userAgent + " GoogleToolbarFF");    
			
			//xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			xmlhttp.setRequestHeader('cookie', ' ');
			xmlhttp.onreadystatechange = function() {
							if (xmlhttp.readyState != 4) 
								return;
							if (xmlhttp.status == 200)
							{
								if (aHandler != null)
								{
									var text = xmlhttp.responseText; 
									objResp.auxObj = text;
									aHandler(objResp);
									
								}
							}
							else
								throw "Error occurred while retrieving from the server!";
								
						};
			xmlhttp.send(postData);
		}
		catch (ex)
		{
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
    
    doAsyncGet  : function (getData, handler, uri)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aHandler = handler, aUri = uri;
			var xmlhttp = this.init();
			if (handler == null)
				aHandler = this.handler;
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
		    		    
			if (getData != "")
			{
				aUri += "?" + getData;
			}
		    
			xmlhttp.open("GET", aUri, true); 
			xmlhttp.onreadystatechange = function() {
	        				if (xmlhttp.readyState != 4) 
								return;
							if (xmlhttp.status == 200)
							{
								if (aHandler != null)
								{
									var text = xmlhttp.responseText; 
									objResp.auxObj = text;
									aHandler(objResp);
								}
							}
							else
								throw "Error occurred while retrieving from the server!";
						};
			xmlhttp.send(null);
		}
		catch (ex)
		{
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
	doAsyncGetXml  : function (getData, handler, uri)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aHandler = handler, aUri = uri;
			var xmlhttp = this.init();
			if (handler == null)
				aHandler = this.handler;
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
		    		    
			if (getData != "")
			{
				aUri += "?" + getData;
			}

			xmlhttp.open("GET", aUri, true); 
			xmlhttp.onreadystatechange = function() {
	        				if (xmlhttp.readyState != 4) 
								return;
							if (xmlhttp.status && xmlhttp.status == 200)
							{
								if (aHandler != null)
								{
									var xml = xmlhttp.responseXML; 
									objResp.auxObj = xml;
									aHandler(objResp);
								}
							}
							else
								throw "Error occurred while retrieving from the server!";
						};
			xmlhttp.send(null);
		}
		catch (ex)
		{
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    

    doSyncGetText  : function (getData, uri)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aUri = uri, respText = null;
			var xmlhttp = this.init();
			//if (this.xmlhttp == null)
			//	this.xmlhttp = this.init();
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
					
			if (getData != "")
			{
				aUri += "?" + getData;
			}
		    
			xmlhttp.open("GET", aUri, false);
			xmlhttp.send(null);
		   
			if (xmlhttp.status == 200)
			{
				objResp.auxObj = xmlhttp.responseText;
				objResp.headers = xmlhttp.getAllResponseHeaders();
			}
			else
			{
				throw xmlhttp.statusText + " " + aUri + " Error occurred while retrieving from the server!";
			}
		}
		catch (ex)
		{
			
			myDump1("ERROR :: " + ex);
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
    doSyncGet  : function (getData, uri)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aUri = uri, respText = null;
			var xmlhttp = this.init();
			//if (this.xmlhttp == null)
			//	this.xmlhttp = this.init();
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
					
			if (getData != "")
			{
				aUri += "?" + getData;
			}
		    
			xmlhttp.open("GET", aUri, false);
			xmlhttp.send(null);
		   
			if (xmlhttp.status == 200)
			{
				objResp.auxObj = xmlhttp.responseText;
				objResp.headers = xmlhttp.getAllResponseHeaders();
			}
			else
			{
				throw xmlhttp.statusText + " " + aUri + " Error occurred while retrieving from the server!";
			}
		}
		catch (ex)
		{
			
			myDump1("ERROR :: " + ex);
			alert(ex);
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
    doSyncGetXml  : function (getData, uri)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aUri = uri, respText = null;
			var xmlhttp = this.init();
			//if (this.xmlhttp == null)
			//	this.xmlhttp = this.init();
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
					
			if (getData != "")
			{
				aUri += "?" + getData;
			}
		    
			xmlhttp.open("GET", aUri, false);
			xmlhttp.send(null);
		   
			if (xmlhttp.status == 200)
			{
				objResp.auxObj = xmlhttp.responseXML;
				objResp.headers = xmlhttp.getAllResponseHeaders();
			}
			else
			{
				throw xmlhttp.statusText + " " + aUri + " Error occurred while retrieving from the server!";
			}
		}
		catch (ex)
		{
			
			myDump1("ERROR :: " + ex);
			alert(ex);
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
    
    doSyncPost  : function (postData, getData, uri, contentType)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var  aUri = uri, respText = null;
			var xmlhttp = this.init();
			//if (this.xmlhttp == null)
			//	this.xmlhttp = this.init();
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
			if (getData != "")
			{
				aUri += "?" + getData;
			}
			
			xmlhttp.open("POST", aUri, false); 
			if (contentType == null)
			    contentType = 'application/x-www-form-urlencoded';
			
			var httpHandler = Components.classes["@mozilla.org/network/protocol;1?name=http"].getService(Components.interfaces.nsIHttpProtocolHandler)
			
			xmlhttp.setRequestHeader('User-Agent', httpHandler.userAgent + " GoogleToolbarFF");    
			
			xmlhttp.setRequestHeader('Content-Type', contentType);
			xmlhttp.setRequestHeader('Content-Length', postData.length);
			xmlhttp.send(postData);

			if (xmlhttp.status == 200)
			{
				objResp.headers = xmlhttp.getAllResponseHeaders();
				objResp.auxObj =  xmlhttp.responseText;	
			}
			else
			{
				throw xmlhttp.statusText + " " + aUri + " Error occurred while retrieving from the server!";
			}
		}
		catch (ex)
		{
			myDump1("ERROR P:: " + ex);
			alert(ex);
			return new WebResponse(1, ex);
		}
		delete xmlhttp;
		return objResp;
    },
    
    doAsyncFile  : function (postData, getData, uri, BOUNDARY)
    {
		try
		{
			var objResp = new WebResponse(0, "");
			var aUri = uri, respText = null;
			var xmlhttp = this.init();
			//if (this.xmlhttp == null)
			//	this.xmlhttp = this.init();
			if (uri == null)
				aUri = this.uri;
		   
			if (xmlhttp == false)
				throw "Error initializing the object";
			if (getData != "")
			{
				aUri += "?" + getData;
			}
			
			xmlhttp.open("POST", aUri, true); 
			xmlhttp.setRequestHeader("Content-Type","multipart/form-data; boundary=" + BOUNDARY);
            xmlhttp.setRequestHeader("Content-Length", (postData.available()));
            
            var tRow = xhttp.auxObj;        
          
          xmlhttp.onprogress = function (a, b)
                                {
                                  
                                    myDump1(a);

                                }; 
            
           xmlhttp.onload = function (evt)
           {
                
                alert(evt.target.responseText);
           }//gActionTreeView.CheckFileLoad("11");
//            xmlhttp.onreadystatechange = function() {
//	        				if (xmlhttp.readyState != 4) 
//								return;
//							try 
//							{
//							    myDump1("A " + xmlhttp.readyState + ", " + xmlhttp.responseText);
//							    var status = xmlhttp.status;
//							}
//							catch (e)
//							{
//							    return;
//							}
//							
//							if (xmlhttp.status == 200)
//							{
//							    var text = xmlhttp.responseText; 
//								objResp.auxObj = text;
//								//alert(tRow);
//								myDump1(text);
//								gActionTreeView.CheckFileLoad(tRow);
//							}
//							else
//								throw "Error occurred while retrieving from the server!";
//						};
             xmlhttp.send(postData); 
             
//            var fileSent = false;
//            DelayExec(10000);
            alert("AER");
//            while (!fileSent)
//            {
//                try 
//                {
//                    if (xmlhttp.status == 200)
//			        {
//			        fileSent = true;   	
//				        objResp.auxObj =  xmlhttp.responseText;	
//			        }
//			        else
//			        {
//				        throw 1
//			        }
//			    }
//			    catch (ex)
//			    {
//			        if (ex == 1)
//			            fileSent = 1;
//			        
//			    }
//		    }	
		}
		catch (ex)
		{
			myDump1("ERROR P:: " + ex);
			alert(ex);
			return new WebResponse(1, ex);
		}
		//alert("AER");
		//delete xmlhttp;
		return objResp;
    }
};
    
    
